Nat Gateways - Create Or Update

Creates or updates a nat gateway.

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/natGateways/{natGatewayName}?api-version=2025-05-01

URI Parameters

Name In Required Type Description
natGatewayName
path True

string

The name of the nat gateway.

resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

subscriptionId
path True

string (uuid)

The ID of the target subscription. The value must be an UUID.

api-version
query True

string

minLength: 1

The API version to use for this operation.

Request Body

Name Type Description
id

string

Resource ID.

location

string

Resource location.

properties.idleTimeoutInMinutes

integer (int32)

The idle timeout of the nat gateway.

properties.publicIpAddresses

Common.SubResource[]

An array of public ip addresses V4 associated with the nat gateway resource.

properties.publicIpAddressesV6

Common.SubResource[]

An array of public ip addresses V6 associated with the nat gateway resource.

properties.publicIpPrefixes

Common.SubResource[]

An array of public ip prefixes V4 associated with the nat gateway resource.

properties.publicIpPrefixesV6

Common.SubResource[]

An array of public ip prefixes V6 associated with the nat gateway resource.

properties.serviceGateway

Common.SubResource

Reference to an existing service gateway.

properties.sourceVirtualNetwork

Common.SubResource

A reference to the source virtual network using this nat gateway resource.

sku

Common.NatGatewaySku

The nat gateway SKU.

tags

object

Resource tags.

zones

string[]

A list of availability zones denoting the zone in which Nat Gateway should be deployed.

Responses

Name Type Description
200 OK

Common.NatGateway

Resource 'NatGateway' update operation succeeded

201 Created

Common.NatGateway

Resource 'NatGateway' create operation succeeded

Headers

Retry-After: integer

202 Accepted

The request has been accepted for processing, but processing has not yet completed.

Headers

  • Azure-AsyncOperation: string
  • Retry-After: integer
Other Status Codes

Common.CloudError

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

Create nat gateway
Create nat gateway with service gateway
Create nat gateway with StandardV2 Sku

Create nat gateway

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/natGateways/test-natgateway?api-version=2025-05-01

{
  "location": "westus",
  "properties": {
    "publicIpAddresses": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/PublicIpAddress1"
      }
    ],
    "publicIpPrefixes": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPPrefixes/PublicIpPrefix1"
      }
    ]
  },
  "sku": {
    "name": "Standard"
  }
}

Sample response

{
  "name": "test-natGateway",
  "type": "Microsoft.Network/natGateways",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/natGateways/test-natGateway",
  "location": "westus",
  "properties": {
    "idleTimeoutInMinutes": 5,
    "provisioningState": "Succeeded",
    "publicIpAddresses": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/PublicIpAddress1"
      }
    ],
    "publicIpPrefixes": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPPrefixes/PublicIpPrefix1"
      }
    ],
    "subnets": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualNetworks/test-vnet/subnets/subnet1"
      }
    ]
  },
  "sku": {
    "name": "Standard"
  }
}
{
  "name": "test-natGateway",
  "type": "Microsoft.Network/natGateways",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/natGateways/test-natGateway",
  "location": "westus",
  "properties": {
    "idleTimeoutInMinutes": 5,
    "provisioningState": "Succeeded",
    "publicIpAddresses": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/PublicIpAddress1"
      }
    ],
    "publicIpPrefixes": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPPrefixes/PublicIpPrefix1"
      }
    ],
    "subnets": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualNetworks/test-vnet/subnets/subnet1"
      }
    ]
  },
  "sku": {
    "name": "Standard"
  }
}

Create nat gateway with service gateway

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/natGateways/test-natgateway?api-version=2025-05-01

{
  "location": "westus",
  "properties": {
    "publicIpAddresses": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/PublicIpAddress1"
      }
    ],
    "publicIpPrefixes": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPPrefixes/PublicIpPrefix1"
      }
    ],
    "serviceGateway": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/serviceGateways/SG1"
    }
  },
  "sku": {
    "name": "Standard"
  }
}

Sample response

{
  "name": "test-natGateway",
  "type": "Microsoft.Network/natGateways",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/natGateways/test-natGateway",
  "location": "westus",
  "properties": {
    "idleTimeoutInMinutes": 5,
    "provisioningState": "Succeeded",
    "publicIpAddresses": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/PublicIpAddress1"
      }
    ],
    "publicIpPrefixes": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPPrefixes/PublicIpPrefix1"
      }
    ],
    "serviceGateway": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/serviceGateways/SG1"
    }
  },
  "sku": {
    "name": "Standard"
  }
}
{
  "name": "test-natGateway",
  "type": "Microsoft.Network/natGateways",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/natGateways/test-natGateway",
  "location": "westus",
  "properties": {
    "idleTimeoutInMinutes": 5,
    "provisioningState": "Succeeded",
    "publicIpAddresses": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/PublicIpAddress1"
      }
    ],
    "publicIpPrefixes": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPPrefixes/PublicIpPrefix1"
      }
    ],
    "serviceGateway": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/serviceGateways/SG1"
    }
  },
  "sku": {
    "name": "Standard"
  }
}

Create nat gateway with StandardV2 Sku

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/natGateways/test-natgateway?api-version=2025-05-01

{
  "location": "westus",
  "properties": {
    "publicIpAddresses": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/PublicIpAddress1"
      }
    ],
    "publicIpPrefixes": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPPrefixes/PublicIpPrefix1"
      }
    ]
  },
  "sku": {
    "name": "StandardV2"
  }
}

Sample response

{
  "name": "test-natGateway",
  "type": "Microsoft.Network/natGateways",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/natGateways/test-natGateway",
  "location": "westus",
  "properties": {
    "idleTimeoutInMinutes": 5,
    "provisioningState": "Succeeded",
    "publicIpAddresses": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/PublicIpAddress1"
      }
    ],
    "publicIpPrefixes": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPPrefixes/PublicIpPrefix1"
      }
    ],
    "sourceVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualNetworks/test-vnet"
    },
    "subnets": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualNetworks/test-vnet/subnets/subnet1"
      }
    ]
  },
  "sku": {
    "name": "StandardV2"
  }
}
{
  "name": "test-natGateway",
  "type": "Microsoft.Network/natGateways",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/natGateways/test-natGateway",
  "location": "westus",
  "properties": {
    "idleTimeoutInMinutes": 5,
    "provisioningState": "Succeeded",
    "publicIpAddresses": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/PublicIpAddress1"
      }
    ],
    "publicIpAddressesV6": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPAddresses/PublicIpAddress2"
      }
    ],
    "publicIpPrefixes": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPPrefixes/PublicIpPrefix1"
      }
    ],
    "publicIpPrefixesV6": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/publicIPPrefixes/PublicIpPrefix2"
      }
    ],
    "sourceVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualNetworks/test-vnet"
    },
    "subnets": [
      {
        "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualNetworks/test-vnet/subnets/subnet1"
      }
    ]
  },
  "sku": {
    "name": "StandardV2"
  }
}

Definitions

Name Description
Common.CloudError

An error response from the service.

Common.CloudErrorBody

An error response from the service.

Common.NatGateway

Nat Gateway resource.

Common.NatGatewaySku

SKU of nat gateway.

Common.SubResource

Reference to another subresource.

NatGatewaySkuName

Name of Nat Gateway SKU.

ProvisioningState

The provisioning state of the application security group resource.

Common.CloudError

An error response from the service.

Name Type Description
error

Common.CloudErrorBody

Cloud error body.

Common.CloudErrorBody

An error response from the service.

Name Type Description
code

string

An identifier for the error. Codes are invariant and are intended to be consumed programmatically.

details

Common.CloudErrorBody[]

A list of additional details about the error.

message

string

A message describing the error, intended to be suitable for display in a user interface.

target

string

The target of the particular error. For example, the name of the property in error.

Common.NatGateway

Nat Gateway resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

location

string

Resource location.

name

string

Resource name.

properties.idleTimeoutInMinutes

integer (int32)

The idle timeout of the nat gateway.

properties.provisioningState

ProvisioningState

The provisioning state of the NAT gateway resource.

properties.publicIpAddresses

Common.SubResource[]

An array of public ip addresses V4 associated with the nat gateway resource.

properties.publicIpAddressesV6

Common.SubResource[]

An array of public ip addresses V6 associated with the nat gateway resource.

properties.publicIpPrefixes

Common.SubResource[]

An array of public ip prefixes V4 associated with the nat gateway resource.

properties.publicIpPrefixesV6

Common.SubResource[]

An array of public ip prefixes V6 associated with the nat gateway resource.

properties.resourceGuid

string

The resource GUID property of the NAT gateway resource.

properties.serviceGateway

Common.SubResource

Reference to an existing service gateway.

properties.sourceVirtualNetwork

Common.SubResource

A reference to the source virtual network using this nat gateway resource.

properties.subnets

Common.SubResource[]

An array of references to the subnets using this nat gateway resource.

sku

Common.NatGatewaySku

The nat gateway SKU.

tags

object

Resource tags.

type

string

Resource type.

zones

string[]

A list of availability zones denoting the zone in which Nat Gateway should be deployed.

Common.NatGatewaySku

SKU of nat gateway.

Name Type Description
name

NatGatewaySkuName

Name of Nat Gateway SKU.

Common.SubResource

Reference to another subresource.

Name Type Description
id

string

Resource ID.

NatGatewaySkuName

Name of Nat Gateway SKU.

Value Description
Standard

Standard

StandardV2

StandardV2

ProvisioningState

The provisioning state of the application security group resource.

Value Description
Failed

Failed

Succeeded

Succeeded

Canceled

Canceled

Creating

Creating

Updating

Updating

Deleting

Deleting